#ifndef _AUTO_REF3_H_
#define _AUTO_REF3_H_

#include<windows.h>

template<class T>
class auto_ref{
	struct item_st{	
		long count;
		CRITICAL_SECTION mutex;
		T obj;
	}*data_ref;
	class Proxy {
		item_st *ref;
    public:
 		Proxy(item_st* obj):ref(obj) {
			EnterCriticalSection(&ref->mutex);
		}
		~Proxy() {
			LeaveCriticalSection(&ref->mutex);
		}
		T* operator->() 
		{
			return &ref->obj;
		}
    };
	void Free(item_st *ref) {
		if(!ref) return;
		if(!InterlockedDecrement(&ref->count)) delete ref;
	}
	void New() {		
		if(data_ref) return;
		data_ref=new item_st; 
		data_ref->count=1;
		InitializeCriticalSection(&data_ref->mutex);
	}
public:
	auto_ref &operator =(auto_ref &obj) {
		item_st *temp=data_ref;
		data_ref=obj.data_ref;
		if(data_ref) InterlockedIncrement(&data_ref->count);
		Free(temp);
		return *this;
	}
	auto_ref &operator =(const T &obj) {
		New();
		data_ref->obj=obj;
		return *this;
	}
	Proxy operator ->() { 
		New(); 
		return Proxy(data_ref);
	}
	operator T&() {
		New();
		return data_ref->obj;
	}
	operator T*() {
		New();
		return &data_ref->obj;
	}
	auto_ref() { 
		data_ref=0;
	}
	auto_ref(auto_ref &obj) {
		operator=(obj);
	}
	~auto_ref() {
		Free(data_ref);
	}
};


#endif
